# Here you can find constants for almost all numerics defined in RFC (see link below).
# You can use `@numeric` instead of `ProtonBot::Numeric` while developing plugins.
# @see https://tools.ietf.org/html/rfc2812#section-5
module ProtonBot::Numeric
  WELCOME = '001'.freeze
  YOURHOST = '002'.freeze
  CREATED = '003'.freeze
  MYINFO = '004'.freeze
  BOUNCE = '005'.freeze
  ISON = '303'.freeze
  AWAY = '301'.freeze
  UNAWAY = '305'.freeze
  NOWAWAY = '306'.freeze
  WHOISUSER = '311'.freeze
  WHOISSERVER = '312'.freeze
  WHOISOPERATOR = '313'.freeze
  WHOISIDLE = '317'.freeze
  WHOISCHANNELS = '319'.freeze
  ENDOFWHOIS = '318'.freeze
  WHOWASUSER = '314'.freeze
  ENDOFWHOWAS = '369'.freeze
  LISTSTART = '321'.freeze
  LIST = '322'.freeze
  LISTEND = '323'.freeze
  USERHOST = '302'.freeze
  UNIQOPIS = '325'.freeze
  CHANNELMODEIS = '324'.freeze
  NOTOPIC = '331'.freeze
  TOPIC = '332'.freeze
  INVITING = '341'.freeze
  SUMMONING = '342'.freeze
  INVITELIST = '346'.freeze
  ENDOFINVITELIST = '347'.freeze
  EXCEPTLIST = '348'.freeze
  ENDOFEXCEPTLIST = '349'.freeze
  VERSION = '351'.freeze
  WHOREPLY = '352'.freeze
  ENDOFWHO = '315'.freeze
  NAMREPLY = '353'.freeze
  ENDOFNAMES = '366'.freeze
  LINKS = '364'.freeze
  ENDOFLINKS = '365'.freeze
  BANLIST = '367'.freeze
  ENDOFBANLIST = '368'.freeze
  INFO = '371'.freeze
  ENDOFINFO = '374'.freeze
  MOTDSTART = '375'.freeze
  MOTD = '372'.freeze
  ENDOFMOTD = '376'.freeze
  YOUREOPER = '381'.freeze
  REHASHING = '382'.freeze
  YOURSERVICE = '383'.freeze
  TIME = '391'.freeze
  USERSTART = '392'.freeze
  USERS = '393'.freeze
  ENDOFUSERS = '394'.freeze
  TRACELINK = '200'.freeze
  TRACECONNECTING = '201'.freeze
  TRACEHANDSHAKE = '202'.freeze
  TRACEUNKNOWN = '203'.freeze
  TRACEOPERATOR = '204'.freeze
  TRACEUSER = '205'.freeze
  TRACESERVER = '206'.freeze
  TRACESERVICE = '207'.freeze
  TRACENEWTYPE = '208'.freeze
  TRACECLASS = '209'.freeze
  TRACERECONNECT = '210'.freeze
  TRACELOG = '261'.freeze
  TRACEEND = '262'.freeze
  STATSLINKINFO = '211'.freeze
  STATSCOMMANDS = '212'.freeze
  ENDOFSTATS = '219'.freeze
  STATSUPTIME = '242'.freeze
  STATSOLINE = '243'.freeze
  UMDODEIS = '221'.freeze
  SERVLIST = '234'.freeze
  SERVLISTEND = '235'.freeze
  LUSERCLIENT = '251'.freeze
  LUSEROP = '252'.freeze
  LUSERUNKNOWN = '253'.freeze
  LUSERCHANNELS = '254'.freeze
  LUSERME = '255'.freeze
  ADMINME = '256'.freeze
  ADMINLOC1 = '257'.freeze
  ADMINLOC2 = '258'.freeze
  ADMINEMAIL = '259'.freeze
  TRYAGAIN = '263'.freeze
  NOSUCHSERVER = '402'.freeze
  NOSUCHCHANNEL = '403'.freeze
  CANNOTSENDTOCHAN = '404'.freeze
  TOOMANYCHANNELS = '405'.freeze
  WASNOSUCHNICK = '406'.freeze
  TOOMANYTARGETS = '407'.freeze
  NOSUCHSERVICE = '408'.freeze
  NOORIGIN = '409'.freeze
  NORECIPIENT = '411'.freeze
  NOTEXTTOSEND = '412'.freeze
  NOTOPLEVEL = '413'.freeze
  WILDTOPLEVEL = '414'.freeze
  BADMASK = '415'.freeze
  UNKNOWNCOMMAND = '421'.freeze
  NOMOTD = '422'.freeze
  NOADMININFO = '423'.freeze
  FILEERROR = '424'.freeze
  NONICKNAMEGIVEN = '431'.freeze
  ERRONEUSNICKNAME = '432'.freeze
  NICKNAMEINUSE = '433'.freeze
  NICKCOLLISION = '436'.freeze
  UNAVAILRESOURCE = '437'.freeze
  USERNOTINCHANNEL = '441'.freeze
  NOTONCHANNEL = '442'.freeze
  USERONCHANNEL = '443'.freeze
  NOLOGIN = '444'.freeze
  SUMMONDISABLED = '445'.freeze
  USERSDISABLED = '446'.freeze
  NOTREGISTERED = '451'.freeze
  NEEDMOREPARAMS = '461'.freeze
  ALREADYREGISTRED = '462'.freeze
  NOPERMFORHOST = '463'.freeze
  PASSWDMISMATCH = '464'.freeze
  YOUREBANNEDCREEP = '465'.freeze
  YOUWILLBEBANNED = '466'.freeze
  KEYSET = '467'.freeze
  CHANNELISFULL = '471'.freeze
  UNKNOWNMODE = '472'.freeze
  INVITEONLYCHAN = '473'.freeze
  BANNEDFROMCHAN = '474'.freeze
  BADCHANNELKEY = '475'.freeze
  BADCHANMASK = '476'.freeze
  NOCHANMODES = '477'.freeze
  BANLISTFULL = '478'.freeze
  NOPRIVILEGES = '481'.freeze
  CHANOPRIVSNEEDED = '482'.freeze
  CANTKILLSERVER = '483'.freeze
  RESTRICTED = '484'.freeze
  UNIQOPPRIVSNEEDED = '485'.freeze
  NOOPERHOST = '491'.freeze
  UMODEUNKNOWNFLAG = '501'.freeze
  USERSDONTMATCH = '502'.freeze
end
